const { Builder, By, Key, until } = require('selenium-webdriver')
const { actionDictionary, stateDictionary, executeAction, assertState } = require('./Dictionary.js')

describe('Filtern und nutzen des Stundenplans', function () {
    this.timeout(60000)
    let driver
    let vars
    beforeEach(async function () {
        driver = await new Builder().forBrowser(require('../../../envHelpers').getBrowser()).build()
        // Setze die Gerätegröße auf eine mobile Ansicht (Bsp. iPhone XR)
        let x = 0;
        let y = 0;
        let width = 414;
        let height = 896;
        await driver.manage().window().setSize({ x, y, width, height });

        // Warte auf das Laden der Webseite
        await driver.wait(until.elementLocated(By.css('body')));
        vars = {}
    })
    afterEach(async function () {
        await driver.quit();
    })
    // We set the weight for e_clearFilter coming from v_GefilterteAnsicht to 0.5
    it('Testpfadgenerator (bsp. Pfadgenerator: weighted_random(edge-coverage=100))', async function () {
        await executeAction(driver, actionDictionary.e_WebsiteOeffnen);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInLecturerFilterEintragen);
        await assertState(driver, stateDictionary.v_LecturerFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInSemesterFilterEintragen);
        await assertState(driver, stateDictionary.v_SemesterFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInRaumFilterEintragen);
        await assertState(driver, stateDictionary.v_RaumFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInModulFilterEintragen);
        await assertState(driver, stateDictionary.v_ModuleFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInTeachingUnitFilterEintragen);
        await assertState(driver, stateDictionary.v_TeachingUnitFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInLecturerFilterEintragen);
        await assertState(driver, stateDictionary.v_LecturerFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInSemesterFilterEintragen);
        await assertState(driver, stateDictionary.v_SemesterFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInStudyProgrammFilterEintragen);
        await assertState(driver, stateDictionary.v_StudyProgrammFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInTeachingUnitFilterEintragen);
        await assertState(driver, stateDictionary.v_TeachingUnitFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInSemesterFilterEintragen);
        await assertState(driver, stateDictionary.v_SemesterFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_AufModulImKalenderKlicken);
        await assertState(driver, stateDictionary.v_ModulModalGeoeffnet);
        await executeAction(driver, actionDictionary.e_AufDetailsKlicken);
        await assertState(driver, stateDictionary.v_WeitergeleitetAufModulinfos);
        await executeAction(driver, actionDictionary.e_ZurueckNavigieren);
        // await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_AufModulImKalenderKlicken);
        await assertState(driver, stateDictionary.v_ModulModalGeoeffnet);
        await executeAction(driver, actionDictionary.e_AufDetailsKlicken);
        await assertState(driver, stateDictionary.v_WeitergeleitetAufModulinfos);
        await executeAction(driver, actionDictionary.e_ZurueckNavigieren);
        // await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInStudyProgrammFilterEintragen);
        await assertState(driver, stateDictionary.v_StudyProgrammFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInRaumFilterEintragen);
        await assertState(driver, stateDictionary.v_RaumFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_AufModulImKalenderKlicken);
        await assertState(driver, stateDictionary.v_ModulModalGeoeffnet);
        await executeAction(driver, actionDictionary.e_AufDetailsKlicken);
        await assertState(driver, stateDictionary.v_WeitergeleitetAufModulinfos);
        await executeAction(driver, actionDictionary.e_ZurueckNavigieren);
        // await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInTeachingUnitFilterEintragen);
        await assertState(driver, stateDictionary.v_TeachingUnitFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInRaumFilterEintragen);
        await assertState(driver, stateDictionary.v_RaumFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInLecturerFilterEintragen);
        await assertState(driver, stateDictionary.v_LecturerFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInRaumFilterEintragen);
        await assertState(driver, stateDictionary.v_RaumFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInLecturerFilterEintragen);
        await assertState(driver, stateDictionary.v_LecturerFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInModulFilterEintragen);
        await assertState(driver, stateDictionary.v_ModuleFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInModulFilterEintragen);
        await assertState(driver, stateDictionary.v_ModuleFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInLecturerFilterEintragen);
        await assertState(driver, stateDictionary.v_LecturerFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInModulFilterEintragen);
        await assertState(driver, stateDictionary.v_ModuleFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInLecturerFilterEintragen);
        await assertState(driver, stateDictionary.v_LecturerFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_AufModulImKalenderKlicken);
        await assertState(driver, stateDictionary.v_ModulModalGeoeffnet);
        await executeAction(driver, actionDictionary.e_AufDetailsKlicken);
        await assertState(driver, stateDictionary.v_WeitergeleitetAufModulinfos);
        await executeAction(driver, actionDictionary.e_ZurueckNavigieren);
        // await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInLecturerFilterEintragen);
        await assertState(driver, stateDictionary.v_LecturerFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInLecturerFilterEintragen);
        await assertState(driver, stateDictionary.v_LecturerFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInTeachingUnitFilterEintragen);
        await assertState(driver, stateDictionary.v_TeachingUnitFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInTeachingUnitFilterEintragen);
        await assertState(driver, stateDictionary.v_TeachingUnitFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInTeachingUnitFilterEintragen);
        await assertState(driver, stateDictionary.v_TeachingUnitFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInSemesterFilterEintragen);
        await assertState(driver, stateDictionary.v_SemesterFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInTeachingUnitFilterEintragen);
        await assertState(driver, stateDictionary.v_TeachingUnitFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInSemesterFilterEintragen);
        await assertState(driver, stateDictionary.v_SemesterFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInTeachingUnitFilterEintragen);
        await assertState(driver, stateDictionary.v_TeachingUnitFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInRaumFilterEintragen);
        await assertState(driver, stateDictionary.v_RaumFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInLecturerFilterEintragen);
        await assertState(driver, stateDictionary.v_LecturerFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInTeachingUnitFilterEintragen);
        await assertState(driver, stateDictionary.v_TeachingUnitFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInStudyProgrammFilterEintragen);
        await assertState(driver, stateDictionary.v_StudyProgrammFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInModulFilterEintragen);
        await assertState(driver, stateDictionary.v_ModuleFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInTeachingUnitFilterEintragen);
        await assertState(driver, stateDictionary.v_TeachingUnitFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInRaumFilterEintragen);
        await assertState(driver, stateDictionary.v_RaumFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInStudyProgrammFilterEintragen);
        await assertState(driver, stateDictionary.v_StudyProgrammFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInModulFilterEintragen);
        await assertState(driver, stateDictionary.v_ModuleFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInTeachingUnitFilterEintragen);
        await assertState(driver, stateDictionary.v_TeachingUnitFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInTeachingUnitFilterEintragen);
        await assertState(driver, stateDictionary.v_TeachingUnitFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInSemesterFilterEintragen);
        await assertState(driver, stateDictionary.v_SemesterFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInRaumFilterEintragen);
        await assertState(driver, stateDictionary.v_RaumFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInSemesterFilterEintragen);
        await assertState(driver, stateDictionary.v_SemesterFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInRaumFilterEintragen);
        await assertState(driver, stateDictionary.v_RaumFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_DatenInLecturerFilterEintragen);
        await assertState(driver, stateDictionary.v_LecturerFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_Clear_Filter);
        await assertState(driver, stateDictionary.v_UngefilterteAnsicht);
        await executeAction(driver, actionDictionary.e_DatenInStudyProgrammFilterEintragen);
        await assertState(driver, stateDictionary.v_StudyProgrammFilterGefuellt);
        await executeAction(driver, actionDictionary.e_AutomatischeFilterung);
        await assertState(driver, stateDictionary.v_AnsichtGefiltert);
        await executeAction(driver, actionDictionary.e_AufModulImKalenderKlicken);
        await assertState(driver, stateDictionary.v_ModulModalGeoeffnet);
    })
})
